from __future__ import division
import wcs, es, random, gamethread, playerlib
from wcs import wcs

info = es.AddonInfo() 
info['name']        = "SPARTAN-II"
info['version']     = "1.2.28"
info['author']      = "Largo Usagi"
info['url']         = "bfs.myftp.org"
info['description'] = "SPARTAN-II by Largo Usagi"

racename="SPARTAN-II"

es.ServerVar('SpartanIIversion',info.version,'Current Soul Reaver Version').makepublic()

rifleList = 'weapon_galil weapon_famas weapon_ak47weapon_scout weapon_m4a1 weapon_sg550 weapon_g3sg1 weapon_awp weapon_sg552 weapon_aug'
pistolList = 'weapon_glock weapon_usp weapon_p228 weapon_deagle weapon_fiveseven weapon_elite'
cqbList = 'weapon_tmp weapon_mac10 weapon_mp5navy weapon_ump45 weapon_p90 weapon_m3 weapon_xm1014'

wcs.Race(racename).registerSkill("Melee Mastery",5,1,"Your melee weapons do extra damage.")
wcs.Race(racename).registerSkill("Ghost",5,3,"You are a master of hiding.")
wcs.Race(racename).registerSkill("Power Armor",5,2,"Your armor is more powerful and gives you life support.")
wcs.Race(racename).registerSkill("Rifle Mastery",5,1,"Your rifles do extra damage.")
wcs.Race(racename).registerSkill("CQB Mastery",5,1,"Your close quarters weapons do extra damage.")
wcs.Race(racename).registerSkill("Pistol Mastery",5,1,"Your pistols do extra damage.")
wcs.Race(racename).registerUltimate("Aim for the head",20,1,1,"One shot, for Massive Damage.")

es.doblock('corelib/noisy_on')

def prep_hurt(ev):
    userid=int(ev['userid'])
    attacker=int(ev['attacker'])
    weapon = ev['es_attackerweapon']
    if wcs.GetRace(attacker)=="SPARTAN-II":
        
        
        if weapon in rifleList:
            rmLevel = wcs.GetLevel(userid,racename,"Rifle Mastery")
            damageMod = rmLevel * 2.5
            damageMod = int(damageMod)
            wcs.Command(userid).Damage(damageMod,2,attacker)
            es.tell(attacker, "#green", "Hit target for more.")
            es.tell(userid, "#green", "You were hit by a Spartan")

        if weapon in cqbList:
            cLevel = wcs.GetLevel(userid,racename,"CQB Mastery")
            damageMod = cLevel * 2.5
            damageMod = int(damageMod)
            wcs.Command(userid).Damage(damageMod,2,attacker)
            es.tell(attacker, "#green", "Hit target for more.")
            es.tell(userid, "#green", "You were hit by a Spartan")
            
        if weapon in pistolList:
            pLevel = wcs.GetLevel(userid,racename,"Pistol Mastery")
            damageMod = pLevel * 2.9
            damageMod = int(damageMod)
            wcs.Command(userid).Damage(damageMod,2,attacker)
            es.tell(attacker, "#green", "Hit target for more.")
            es.tell(userid, "#green", "You were hit by a Spartan")
        
        if weapon == "weapon_knife":
            mLevel = wcs.GetLevel(userid,racename,"Melee Mastery")
            damageMod = mLevel * 10
            damageMod = int(damageMod)
            wcs.Command(userid).Damage(damageMod,2,attacker)
            es.tell(attacker, "#green", "Hit target for more.")
            es.tell(userid, "#green", "You were hit by a Spartan.")

def player_ultimate_on(ev):
    userid = int(ev['userid'])
    if wcs.GetRace(userid)=="Aim for the head":
      if wcs.GetLevel(userid,racename,"Aim for the head") == 1:
        if wcs.Command(userid).ReturnDict('fired') == 0:
            wcs.Command(userid).UpdateDict('oneShot', 1)
            es.tell(userid, "#green", "Aim For The Head.")
        if wcs.Command(userid).ReturnDict('fired') == 1:
            es.tell(userid, "#green", "Already Used.")

def weapon_fire(ev):
    userid=int(ev['userid'])
    if wcs.GetRace(userid)=="SPARTAN-II":
        if wcs.Command(userid).ReturnDict('oneShot') == 1:
            if wcs.Command(userid).ReturnDict('fired') == 0:
                wcs.Command(userid).UpdateDict('fired', 1)
                target = wcs.Command(ev["userid"]).GetViewPlayer()
                wcs.Command(target).Damage(90,2,userid)
                wcs.Command(userid).UpdateDict('oneShot', 0)
                es.tell(userid, "#green", "Your Focus Fades.")
            

def player_spawn(ev):
    userid=int(ev['userid'])
    dead = wcs.Command(userid).IsDead()
    if not dead:
        if wcs.GetRace(userid) == "SPARTAN-II":
            wcs.Command(userid).UpdateDict('oneShot', 0)
            wcs.Command(userid).UpdateDict('fired', 0)
            if wcs.GetLevel(userid,racename,"Power Armor") >= 1:
                es.server.queuecmd('es_xgive %s %s'%(userid, 'item_assaultsuit'))
                pArmor = wcs.GetLevel(userid,racename,"Power Armor")
                phArmor = pArmor * 15
                paArmor = wcs.GetLevel(userid,racename,"Power Armor")
                wcs.Command(userid).UpdateDict('armor', paArmor)
                wcs.Command(userid).UpdateDict('armorRegen', 1)
                wcs.Command(userid).UpdateDict('armorRegenCount', 20)
                if wcs.Command(userid).ReturnDict('armorLoop') == 0:
                    armorRegen(userid)
                wcs.Command(userid).HealthAdd(phArmor)
                loc = es.getplayerlocation(userid)
                wcs.Effect().Ring5(loc[0], loc[1], loc[2], 10, 40, 240, 255)
                es.tell(userid, "#green", "Armor Activated.")
        if wcs.GetLevel(userid, racename, 'Ghost'):
            wcs.Command(userid).UpdateDict('location', es.getplayerlocation(userid))
        if not wcs.Command(userid).ReturnDict('looping'):
            hide_loop(userid)
        
def hide_loop(userid):
	if es.exists('userid', userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			if wcs.GetLevel(userid, racename, 'Ghost'):
				wcs.Command(userid).UpdateDict('looping',1)
				location = es.getplayerlocation(userid)
				if location == wcs.Command(userid).ReturnDict('location'):
					wcs.Command(userid).Fade(200/wcs.GetLevel(userid, racename, 'Ghost'), 1)
				else:
					wcs.Command(userid).Color(alpha=255)
					wcs.Command(userid).UpdateDict('location', location)
				gamethread.delayed(5, hide_loop, userid)
		else:
			wcs.Command(userid).UpdateDict('looping',0)

def armorRegen(userid):
    if wcs.Command(userid).ReturnDict('armorRegen') == 1:
        if not playerlib.getPlayer(userid).get('isdead'):
            if wcs.Command(userid).ReturnDict('armorRegenCount') >= 1:
                wcs.Command(userid).UpdateDict('armorLoop', 1)
                wcs.Command(userid).ArmorAdd(wcs.Command(userid).ReturnDict('armor'))
                gamethread.delayed(3, armorRegen, userid)
                num = wcs.Command(userid).ReturnDict('armorRegenCount') - 1
                wcs.Command(userid).UpdateDict('armorRegenCount', num)

def give(userid, item):
    if item.startswith('weapon_') or item.startswith('item_'):
		    es.server.queuecmd('es_xgive %s %s'%(userid, item))
    if item in ('nvgs', 'assualtsuit', 'defusekit'):
        es.server.queuecmd('es_xgive %s item_%s'%(userid, item))
